//  test_57.pde
//  2021.9.23

import processing.serial.*;
import ddf.minim.*;

Minim minim;
AudioPlayer notchsound,levsound;
//AudioSnippet;
Serial myPort;
PImage panel,tenA,tenB,mascon,lever;

void setup() {
  minim = new Minim(this);
  notchsound = minim.loadFile("notchsound.mp3"); 
  levsound = minim.loadFile("levsound.mp3"); 
  
  size (1280,800);
  panel=loadImage("panel-2.png");
  tenA=loadImage("chokusin.png");
  tenB=loadImage("bunki.png");
  mascon=loadImage("masconlever.png");
  lever=loadImage("lever.png");
  myPort=new Serial(this,"COM7",9600);
  
}

int [] vol= {125,407,470,430};
int [] vol1= {0,3,10,1};
int [] vol2= {0,3,10,1};
int [] a = {-400,-200,-80,-30,35,60,80,100,120};
int [] b = {100,80,60,50,50,70,50,50,50};
int [] c = {64,56,48,40,32,24,16,8};
int [] com1={0,0,0,0};
int [] com2={0,0,0,0};

int mox;
int moy;
int notch;
int range;
float dv;
float v=0 ;
int dt;
int pos;

void draw(){
  
 image(panel, 0,0);
 
///入力確認
  mox=mouseX;
  moy=mouseY;
  if (mousePressed){
    if (mouseButton==LEFT){
      if (moy>720){
        if (25<mox && mox<53){com1[0]=0;}  //本線転轍機チェック
        if (65<mox && mox<93){com1[0]=1;}
        if (110<mox && mox<138){com1[1]=0;}  //支線転轍機チェック
        if (150<mox && mox<178){com1[1]=1;}
        if (390<mox && mox<418){com1[2]=0;}  //本線出発信号機チェック       
        if (430<mox && mox<458){com1[2]=1;}        
        if (490<mox && mox<518){com1[3]=0;}  //本線1出発信号機チェック       
        if (530<mox && mox<558){com1[3]=1;}         
     }
     if (moy<560){
       if (1100<mox && mox<1200){vol[0]=moy;}  //マスコンチェック
     }
     if (280<moy && moy<530){
       if (860<mox && mox<930){vol[1]=moy;} //レンジチェック
     }
     if (280<moy && moy<530){
       if (960<mox && mox<1130){vol[2]=moy;} //微調整チェック
     }
     if (380<moy && moy<500){
       if (v==0){
         if (400<mox && mox<480){vol[3]=moy;}  //方向チェック
       }
     }
     if (120<moy && moy<180){
       if (1000<mox && mox<1060){  //緊急スイッチ
         vol[0]=125;
         vol1[0]=0;
       }
     }
  }
 }
  
////入力値の整形
  if(vol[0]<140){vol[0]=140;}   //マスコン
  if(vol[0]>490) {vol[0]=490;}
  vol1[0]= int((vol[0]-140)/40);
  
  if(vol[1]<285){vol[1]=285;}   //レンジ
  if(vol[1]>520) {vol[1]=520;}
  vol1[1]= 7 - int((vol[1]-285)/30);
  
  if(vol[2]<290){vol[2]=290;}   //微調整
  if(vol[2]>490) {vol[2]=490;}
  vol1[2]= int((490-vol[2])/2);
  
  if(vol[3]<380){vol[3]=380;}   //方向
  if(vol[3]>490) {vol[3]=490;}
  vol1[3]= int((vol[3]-380)/40);

////
  if (vol1[0]!=vol2[0]){   //ノッチ操作音
    notchsound.rewind();
    notchsound.play();
    vol2[0] = vol1[0];
  }
  if (vol1[1]!=vol2[1]){   //レンジレバー操作音
    levsound.rewind();
    levsound.play();
    vol2[1] = vol1[1];
  }
  if (vol1[3]!=vol2[3]){   //方向レバー出力と操作音
    myPort.write(251+vol1[3]);
    levsound.rewind();
    levsound.play();
    vol2[3] = vol1[3];
  }
  
////アクション 
    if (com1[0]==0){   //本線転轍機作動
       image(tenA, 20, 520);
       if (com1[0]!=com2[0]){
           myPort.write(202);
           com2[0]=com1[0];
       }
    } else if (com1[0]==1){
       image(tenB, 20, 520);
       if (com1[0]!=com2[0]){
           myPort.write(201);
           com2[0]=com1[0];
       }
    }

    if (com1[1]==0){   //支線転轍機作動
       image(tenA, 100, 520);
       if (com1[1]!=com2[1]){
           myPort.write(204);
           com2[1]=com1[1];
       }
    } else if (com1[1]==1){
       image(tenB, 100, 520);
       if (com1[1]!=com2[1]){
           myPort.write(203);
           com2[1]=com1[1];
       }
    }    
  
  
    if (com1[2]==1){    //本線出発信号機作動
       fill(#FF0000);
       ellipse(420,620,30,30);
       if (com1[2]!=com2[2]){
           myPort.write(212);
           com2[2]=com1[2];
       }
    } else if (com1[2]==0){
       fill(#00FFCC);
       ellipse(420,670,30,30);
       if (com1[2]!=com2[2]){
           myPort.write(211);
           com2[2]=com1[2];
       }
    }
  
    if (com1[3]==1){    //本線1出発信号機作動
       fill(#FF0000);
       ellipse(520,620,30,30);
       if (com1[3]!=com2[3]){
           myPort.write(214);
           com2[3]=com1[3];
       }
    } else if (com1[3]==0){
       fill(#00FFCC);
       ellipse(520,670,30,30);
       if (com1[3]!=com2[3]){
           myPort.write(213);
           com2[3]=com1[3];
       }
    }  
 
  image(mascon,1115,145+(vol1[0]*40));  //レバー類を表示
  image(lever,880,497-(vol1[1]*30));
  image(lever,976,490-(vol1[2]*2));
  image(lever,430,387+(vol1[3]*40));
  
//車速を計算する
  notch = vol1[0];
  dv = a[notch]/(v+b[notch])-0.5;   //加減速度を計算
  v = v + dv;
  if (v<0){v=0;}
  if (v>250){v=250;}
  
  range = vol1[1];     //Duty値を求める
  dt = floor(c[range]*v/100);
  if (dt>99){dt=99;}  
  
  dt = dt + floor(vol1[2]*0.15);  //微調整

  stroke(#FF0000);   //速度計の針表示
  strokeWeight(6);
  strokeCap(SQUARE);
  pos = floor(420+2*v);
  line(pos,142,pos,197);
  
  stroke(#000000);
  strokeWeight(0);
  myPort.write(dt);    //デューティ値を出力
  
  delay(50);
  
}
